﻿using SampleScheduleCRUD.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Collections;
namespace SampleScheduleCRUD
{
    public partial class ScheduleController : Controller
    {
        ScheduleDataDataContext db = new ScheduleDataDataContext();
        public ActionResult ScheduleFeatures()
        {
            return View();
        }

        public JsonResult GetData()
        {
            IEnumerable data = db.Appointments.Take(100);
            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public JsonResult Batch(EditParams Param)
        {
            if (Param.Action == "insert" || (Param.Action == "batch" && Param.Added != null))          // this block of code will execute while inserting the appointments
            {
                var value = Param.Action == "insert" ? Param.Value : Param.Added[0];
                int intMax = db.Appointments.ToList().Count > 0 ? db.Appointments.ToList().Max(p => p.Id) : 1;
                DateTime startTime = Convert.ToDateTime(value.StartTime);
                DateTime endTime = Convert.ToDateTime(value.EndTime);
                Appointment appoint = new Appointment()
                {
                    Id = intMax + 1,
                    StartTime = startTime,
                    EndTime = endTime,
                    Subject = value.Subject,
                    Description = value.Description,
                    AllDay = value.AllDay,
                    Recurrence = value.Recurrence,
                    RecurrenceRule = value.RecurrenceRule
                };
                db.Appointments.InsertOnSubmit(appoint);
                db.SubmitChanges();
            }
            if ((Param.Action == "batch" && Param.Deleted != null) || Param.Action == "remove")   // this block of code will execute while removing the appointment
            {
                if (Param.Action == "remove")
                {
                    int id = Convert.ToInt32(Param.Key);
                    Appointment app = db.Appointments.Where(c => c.Id == id).FirstOrDefault();
                    if (app != null) db.Appointments.DeleteOnSubmit(app);
                }
                else
                {
                    foreach (var dele in Param.Deleted)
                    {
                        int id = Convert.ToInt32(dele.Id);
                        Appointment app = db.Appointments.Where(c => c.Id == id).FirstOrDefault();
                        if (app != null) db.Appointments.DeleteOnSubmit(app);
                    }
                }
                db.SubmitChanges();
            }
            if ((Param.Action == "batch" && Param.Changed != null) || Param.Action == "update")   // this block of code will execute while updating the appointment
            {
                var value = Param.Action == "update" ? Param.Value : Param.Changed[0];
                int id = Convert.ToInt32(value.Id);
                var filterData = db.Appointments.Where(c => c.Id == id);

                if (filterData.Count() > 0)
                {
                    DateTime startTime = Convert.ToDateTime(value.StartTime);
                    DateTime endTime = Convert.ToDateTime(value.EndTime);
                    Appointment appoint = db.Appointments.Single(A => A.Id == id);
                    appoint.StartTime = startTime;
                    appoint.EndTime = endTime;
                    appoint.Subject = value.Subject;
                    appoint.Description = value.Description;
                    appoint.Recurrence = Convert.ToByte(value.Recurrence);
                    appoint.AllDay = value.AllDay;
                    appoint.RecurrenceRule = value.RecurrenceRule;
                }
               
                db.SubmitChanges();
            }
            IEnumerable data = db.Appointments.Take(500);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }

}
